//
//  RepairOrderDetailBgController.swift
//  IFS
//
//  Created by 曹云霄 on 2018/1/12.
//  Copyright © 2018年 上海勾芒信息科技有限公司. All rights reserved.
//

import UIKit
import SnapKit
import SwiftyJSON

class RepairOrderDetailBgController: BaseViewController {

    /// 工单数据
    open var billModel: RepairOrderRecord!
    /// 转交、完成背景
    @IBOutlet weak var bottomBgView: UIView!
    @IBOutlet weak var bottomLayoutHeight: NSLayoutConstraint!
    /// 详情内容背景
    @IBOutlet weak var contentBgView: UIView!
    /// 转交
    @IBOutlet weak var transferButton: UIButton!
    /// 完成
    @IBOutlet weak var completeButton: UIButton!
    /// 工单详情控制器
    lazy final var detailVc: RepairOrderDetailViewController = {
        var detailVc = RepairOrderDetailViewController.instantiateViewController(.Function) as! RepairOrderDetailViewController
        return detailVc
    }()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        addChildBillDetailVc()
    }

    // MARK: - 添加工单详情控制器
    fileprivate func addChildBillDetailVc() {
        detailVc.billModel = billModel
        contentBgView.addSubview(detailVc.view)
        detailVc.view.snp.makeConstraints { (make) in
            make.edges.equalTo(self.contentBgView)
        }
        addChildViewController(detailVc)
        detailVc.setStateBlock {[weak self] (state) in
            /*
             /// - FINISHED: 已完成
             /// - DELETED: 已删除
             /// - CANCLED
             */
            if state == SUBMIT_REPAIR_ORDER_STATE.FINISHED.rawValue || state == SUBMIT_REPAIR_ORDER_STATE.DELETED.rawValue || state == SUBMIT_REPAIR_ORDER_STATE.CANCLED.rawValue {
                self?.bottomLayoutHeight.constant = 0
                UIView.animate(withDuration: 0.5, animations: {
                    self?.view.layoutIfNeeded()
                })
            }else {
                self?.bottomLayoutHeight.constant = 50
                UIView.animate(withDuration: 0.5, animations: {
                    self?.view.layoutIfNeeded()
                })
            }
        }
    }
    
    // MARK: - 转交工单
    @IBAction func transferButtonClickAction(_ sender: UIButton) {
        detailVc.transferRepairOrder()
    }
    
    // MARK: - 传递工单数据到工单完成界面
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        if segue.identifier == RepairOrderCompletedViewController.name() {
            let completeVc = segue.destination as! RepairOrderCompletedViewController
            let model = BillCompletedRequestModel.init(fromJson: JSON(detailVc.orderDetailViewModel.billDetailModel.toDictionary()))
            completeVc.billCompleteViewModel.billCompltedModel = model
        }
    }
}









