//
//  TodoViewController.swift
//  IFS
//
//  Created by 曹云霄 on 2018/1/5.
//  Copyright © 2018年 上海勾芒信息科技有限公司. All rights reserved.
//

import UIKit
import RxCocoa
import RxSwift

class TodoViewController: BaseTableViewPullController {

    /// RxSwift自动释放
    let disposeBag = DisposeBag()
    
    /// TodoViewModel
    lazy final var todoViewModel: TodoViewModel = {
        var todoViewModel = TodoViewModel()
        return todoViewModel
    }()
    
    override func viewDidLoad() {
        super.viewDidLoad()

        tableViewAnimationHeight()
    }

    // MARK: - 加载数据
    override func loadWebDataSource() {
        todoViewModel.queryTodoAction(.ALL).subscribe {[weak self] (event) in
            switch event {
            case .next():
                self?.endRefreshNomoreData()
                break
            case .error(_):
                self?.endRefresh()
                break
            default:
                break
            }
            self?.tableView.reloadData()
            }.disposed(by: disposeBag)
    }
    
    // MARK: - 设置tableview高度
    fileprivate func tableViewAnimationHeight() {
        tableView.rowHeight = UITableViewAutomaticDimension
        tableView.estimatedRowHeight = 80.0
    }
    
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        return todoViewModel.dequeueReusableCell(TodoTableViewCell.name(),indexPath,tableView)
    }
    
    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return todoViewModel.todoResultArray.count
    }
}

















